; ==============================================================================
;   MGSP
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver.	Description
; ==============================================================================

; ==============================================================================
mgsp_body::
		call		file_init
		; TEh`bv̗LEɕ\
		call		grp_sound_chip_indicator
		; x[^[\
		call		grp_update_keyboard_spot
		; ʕ\XV
		ld			a, [master_volume]
		call		grp_update_master_volume
		; [vJEg\
		xor			a, a
		ld			[s_number + 2], a
		ld			a, [loop_counter]
		call		grp_update_loop_count
		; \[g[h\
		ld			a, [sort_mode]
		call		grp_update_sort_mode_info
		; Đ[h\
		ld			a, [play_mode]
		call		grp_update_mode_info
		; t@CXgXV
		ld			a, 1
		call		grp_update_file_list
		call		mgsp_auto_start

; ==============================================================================
; C[v
; ==============================================================================
		scope		mgsp_main_loop
main_loop:
		call		mgsp_common_proc
		call		mgsp_check_key
		jp			main_loop
		endscope

; ==============================================================================
; C[v̒̃L[͈ȊO
; ==============================================================================
		scope		mgsp_common_proc
mgsp_common_proc::
		call		vsync_wait
		call		mgsp_check_song_change
		call		grp_update_keyboard_spot		; A ɉғ̃gbNԂ
		call		mgsp_check_song_stop

		; ȖXN[
		ld			a, [title_scroll_timer]
		dec			a
		ld			[title_scroll_timer], a
		or			a, a
		jp			nz, skip1

		call		update_title
		ld			a, title_scroll_wait
		ld			[title_scroll_timer], a
skip1:
		ret
		endscope

title_scroll_wait := 20

; ==============================================================================
; 1R}҂ (30fps)
; ==============================================================================
		scope		vsync_wait
vsync_wait::
		ld			a, [timer_counter]
		cp			a, 2
		jr			c, vsync_wait
		xor			a, a
		ld			[timer_counter], a
		ret
		endscope

; ==============================================================================
; 샂[hύX
; ==============================================================================
		scope		change_mode
change_mode::
		ld			a, [play_mode]
		inc			a
		cp			a, 3
		jr			nz, skip1
		xor			a, a
skip1:
		ld			[play_mode], a
		jp			grp_update_mode_info
		endscope

; ==============================================================================
; ̋ȂĐ
; ==============================================================================
		scope		start_next_song
start_next_song::
		call		clear_mgsdrv_track_work
		ld			b, fl_files

		; 샂[h𔻕
		ld			a, [play_mode]
		or			a, a
		jp			z, normal_mode
		dec			a
		jp			z, random_mode
repeat_mode:
		ld			a, [playing_song_number]
		jr			check_and_play

random_mode:
		call		get_random			; b ͕ۑ
adjust_random_max:
		cp			a, b
		jr			c, check_and_play
		sub			a, b
		jr			adjust_random_max

normal_mode:
		; Đ̋Ȃ̎̔ԍ𓾂
		ld			a, [playing_song_number]
change_next:
		inc			a
		cp			a, b
		jp			c, check_and_play

		; Ō̋Ȃꍇ́Aŏ֖߂
		xor			a, a
check_and_play:
		ld			c, a
		call		get_current_file_entry
		ld			a, c
		call		play_new_song
		ret
		endscope

; ==============================================================================
; ŐȂĐ
; ==============================================================================
		scope		start_previous_song
start_previous_song::
		call		clear_mgsdrv_track_work
		ld			b, fl_files

		; 샂[h𔻕
		ld			a, [play_mode]
		or			a, a
		jp			z, normal_mode
		dec			a
		jp			z, random_mode
repeat_mode:
		ld			a, [playing_song_number]
		jr			check_and_play

random_mode:
		call		get_random			; b ͕ۑ
adjust_random_max:
		cp			a, b
		jr			c, check_and_play
		sub			a, b
		jr			adjust_random_max

normal_mode:
		; Đ̋Ȃ̑O̔ԍ𓾂
		ld			a, [playing_song_number]
change_previous:
		sub			a, 1
		jp			c, error_start_previous_song

check_and_play:
		ld			c, a
		call		get_current_file_entry
		ld			a, c
		call		play_new_song
		ret

error_start_previous_song::
		xor			a, a
		ld			[play_state], a
		ld			[playing_song_number], a
		ret
		endscope

; ==============================================================================
; ĐJn
; ==============================================================================
		scope		mgsp_auto_start
mgsp_auto_start::
		ld			a, PRM_AUTO_START
		or			a, a
		ret			z
		; Normal[h̏ꍇAŏ̃t@CĐ悤Ɍ݂̋ȔԂ -1 ɂĂ
		ld			a, -1
		ld			[playing_song_number], a	; -1 ɂ
		jp			start_next_song
		endscope

; ==============================================================================
; tԊĎ
; ==============================================================================
		scope		mgsp_check_song_change
mgsp_check_song_change::
		; tI`FbN
		ld			a, [play_state]				; A = 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
		or			a, a
		ret			z							; ~ȂȂɂȂ
		dec			a
		jp			z, play_next_song			; ̋ȍĐ҂Ȃ玟̋ȂĐ
		dec			a
		jp			z, wait_fadeout				; tF[hAEgȂtF[hAEg`FbN

		; t񐔂 loop_counter ɒB?
		ld			a, [play_mode]
		cp			a, 2						; repeat mode ȂAloop񐔃`FbN͂Ȃ
		ret			z
		ld			hl, [mgs_id_mibadr]
		ld			de, mgs_mib_loopct
		add			hl, de
		ld			a, [hl]
		ld			hl, loop_counter
		cp			a, [hl]
		ret			c							; BĂȂȂ牽Ȃ
		call		start_fadeout
		ret
		; tF[hAEg
wait_fadeout:
		ld			a, [fadeout_volume]
		ld			b, a
		ld			a, [fadeout_speed]
		add			a, b
		ld			[fadeout_volume], a
		jp			c, fadeout_end
		srl			a
		srl			a
		srl			a
		srl			a
		call		mgs_msvst
		ei
		ret
fadeout_end:
		; ̋Ȃ̍Đ҂֑J
		call		mgsp_stop_song
		ld			a, 1
		ld			[play_state], a
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret

play_next_song:
		; ̋ȂĐ
		call		start_next_song
		ret
		endscope

; ==============================================================================
; wv\
; ==============================================================================
		scope		mgsp_show_help
mgsp_show_help::
		call		grp_unselect_playing_line
		call		grp_unselect_line
		call		grp_show_help
mgsp_show_messages::
		; XN[o[uXN[Ȃv\ɂ
		call		grp_hide_scroll_bar

		call		release_loop

main_loop:
		call		mgsp_common_proc

		; L[͂Βʏɖ߂
		call		check_key_press
		or			a, a
		jp			nz, exit_help
		jp			main_loop

exit_help:
		ld			a, 1
		ld			[grp_select_line_on], a
		call		grp_update_file_list

		; L[҂
release_loop::
		call		mgsp_common_proc
		call		check_key_press
		or			a, a
		jp			nz, release_loop
		ret
		endscope

; ==============================================================================
; CZX\
; ==============================================================================
		scope		mgsp_show_license
mgsp_show_license::
		call		grp_unselect_playing_line
		call		grp_unselect_line
		call		grp_show_license
		jp			mgsp_show_messages
		endscope

; ==============================================================================
; ĐJn
; ==============================================================================
		scope		mgsp_play_song
mgsp_play_song::
		ld			a, [master_volume]
		call		mgs_msvst
		ei

		ld			a, 0xFF
		ld			h, a
		ld			l, a
		ld			[track_mute], hl
		ld			[track_mute + 2], a

		call		play_song
		ret
		endscope

; ==============================================================================
; Đ~
; ==============================================================================
		scope		mgsp_stop_song
mgsp_stop_song::
		call		clear_mgsdrv_track_work
		call		grp_unselect_playing_line
		xor			a, a
		ld			[fadeout_volume], a
		ld			[play_state], a
		dec			a
		ld			[grp_play_file], a
		call		grp_playing_line
		call		grp_select_line
		ret
		endscope

; ==============================================================================
; Ȃ̍Đ~`FbN
; input)
;	A .... Number of active tracks
; ==============================================================================
		scope		mgsp_check_song_stop
mgsp_check_song_stop::
		or			a, a
		ret			nz					; Đ̃gbNcĂ̂ŉȂ

		ld			a, [play_state]
		or			a, a
		ret			z					; ĐĂȂԂȂ̂ŉȂ

		; ̋ȂĐԂɑJڂ
		ld			a, 1
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; 𓾂
; ==============================================================================
		scope		get_random
get_random::
		ld			a, [random_seed1]
		rlca
		xor			a, 0x24
		ld			[random_seed1], a
		ld			d, a
		ld			a, [random_seed2]
		rrca
		xor			a, 0x41
		ld			[random_seed2], a
		xor			a, d
		add			a, 0x73
		ret
		endscope

; ==============================================================================
; fBNgGgŃ\[g
; ==============================================================================
		scope		sort_by_entry
sort_by_entry::
		call		fl_sort_normal

		ld			a, 1
		call		grp_update_file_list

		xor			a, a
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; ȖŃ\[g
; ==============================================================================
		scope		sort_by_title
sort_by_title::
		call		fl_sort_title

		ld			a, 1
		call		grp_update_file_list

		ld			a, 1
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; t@CŃ\[g
; ==============================================================================
		scope		sort_by_filename
sort_by_filename::
		call		fl_sort_filename

		ld			a, 1
		call		grp_update_file_list

		ld			a, 2
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; Vbt
; ==============================================================================
		scope		sort_by_shuffle
sort_by_shuffle::
		call		fl_sort_shuffle

		ld			a, 1
		call		grp_update_file_list

		ld			a, 3
		ld			[sort_mode], a
		call		grp_update_sort_mode_info
		ret
		endscope

; ==============================================================================
; Ȗ\Et@C\̐؂ւ
; ==============================================================================
		scope		toggle_file_list_mode
toggle_file_list_mode::
		ld			a, [grp_file_list_mode]
		xor			a, 1
		ld			[grp_file_list_mode], a

		ld			a, 1
		jp			grp_update_file_list
		endscope

; ==============================================================================
; tF[hAEgJn
; ==============================================================================
		scope		start_fadeout
start_fadeout::
		ld			a, [play_state]
		cp			a, 3
		ret			nz
		ld			a, [master_volume]
		add			a, a
		add			a, a
		add			a, a
		add			a, a
		ld			[fadeout_volume], a
		ld			a, 2
		ld			[play_state], a
		ret
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		up_select
up_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		jp			grp_update_file_list
		endscope

; ==============================================================================
; ֈړ
; ==============================================================================
		scope		down_select
down_select::
		ld			b, fl_files
		ld			a, [grp_select_file]
		inc			a
		cp			a, b
		ret			nc						; łɈԉȂ牽Ȃ
		ld			[grp_select_file], a
		xor			a, a
		jp			grp_update_file_list
		endscope

; ==============================================================================
; y[WAbv
; ==============================================================================
		scope		left_select
left_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		sub			a, 9
		jr			nc, left_select_clip
		xor			a, a
left_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		jp			grp_update_file_list
		endscope

; ==============================================================================
; y[W_E
; ==============================================================================
		scope		right_select
right_select::
		ld			b, fl_files
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		add			a, 9
		cp			a, b
		jr			c, right_select_clip
		ld			a, b
		dec			a
right_select_clip:
		ld			[grp_select_file], a
		xor			a, a
		jp			grp_update_file_list
		endscope

; ==============================================================================
; y[Wgbv
; ==============================================================================
		scope		minus_select
minus_select::
		ld			a, [grp_select_file]
		or			a, a
		ret			z						; łɈԏȂ牽Ȃ
		xor			a, a
		ld			[grp_select_file], a
		jp			grp_update_file_list
		endscope

; ==============================================================================
; y[W{g
; ==============================================================================
		scope		plus_select
plus_select::
		ld			b, fl_files
		ld			a, [grp_select_file]
		cp			a, b
		ret			z						; łɈԉȂ牽Ȃ
		ld			a, b
		dec			a
		ld			[grp_select_file], a
		xor			a, a
		jp			grp_update_file_list
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_down
loop_down::
		ld			a, [loop_counter]
		dec			a
		ret			z						; ł 1 Ȃ牽Ȃ
		ld			[loop_counter], a
		jp			grp_update_loop_count
		endscope

; ==============================================================================
;	[vJEg
; ==============================================================================
		scope		loop_up
loop_up::
		ld			a, [loop_counter]
		inc			a
		cp			a, 65
		ret			z						; ł 64 Ȃ牽Ȃ
		ld			[loop_counter], a
		jp			grp_update_loop_count
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_up
master_volume_up::
		ld			a, [master_volume]
		dec			a
		ret			m
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	}X^[ 
; ==============================================================================
		scope		master_volume_down
master_volume_down::
		ld			a, [master_volume]
		inc			a
		cp			a, 16
		ret			nc
		ld			[master_volume], a
		call		grp_update_master_volume
		ld			a, [master_volume]
		call		mgs_msvst
		ei
		ret
		endscope

; ==============================================================================
;	ĐxύX (xZbg)
; ==============================================================================
		scope		mgsp_speed_reset
mgsp_speed_reset::
		ld			a, 100
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	ĐxύX
; ==============================================================================
		scope		mgsp_speed_change
mgsp_speed_change::
		ld			b, a
		ld			a, [song_speed]
		add			a, b
		cp			a, 200
		jp			c, skip1
		ld			a, 200
		jp			skip2
skip1:
		cp			a, 20
		jp			nc, skip2
		ld			a, 20
skip2:
		ld			[song_speed], a
		jp			grp_update_speed
		endscope

; ==============================================================================
;	gbN~[g (Lp[g)
; ==============================================================================
		scope		mgsp_track_mute_l
mgsp_track_mute_l::
		ld			hl, [track_mute]
		xor			a, l
		ld			l, a
		ld			[track_mute], hl
		ld			a, [track_mute + 2]
		ld			b, a
		ld			c, 2
		jp			mgs_tmst1
		endscope

; ==============================================================================
;	gbN~[g (Hp[g)
; ==============================================================================
		scope		mgsp_track_mute_h
mgsp_track_mute_h::
		ld			hl, [track_mute]
		xor			a, h
		ld			h, a
		ld			[track_mute], hl
		ld			a, [track_mute + 2]
		ld			b, a
		ld			c, 2
		jp			mgs_tmst1
		endscope

; ==============================================================================
;	gbN~[g (Bp[g)
; ==============================================================================
		scope		mgsp_track_mute_b
mgsp_track_mute_b::
		ld			[track_mute], hl
		ld			b, a
		ld			a, [track_mute + 2]
		xor			a, b
		ld			b, a
		ld			c, 2
		jp			mgs_tmst1
		endscope

; ==============================================================================
;	I𒆂̋ȃf[^Đ
; ==============================================================================
		scope		play_current_song
play_current_song::
		ld			a, [grp_select_file]
play_new_song::
		push		af
		call		grp_unselect_playing_line
		pop			af
		ld			c, a
		ld			[grp_play_file], a
		call		get_current_file_entry

		ld			a, c
		ld			[playing_song_number], a

		call		load_mgs_file_and_show_title
		ret			nz
		call		mgsp_play_song
		; tԂɕύX
		ld			a, 3
		ld			[play_state], a
		xor			a, a
		call		grp_update_file_list
		ret

mgsp_update_file_list_all::
		; J[\ԏɕύX
		xor			a, a
		ld			[grp_select_file], a
		ld			[playing_song_number], a
		; Đ̋\͔\ɕύX
		dec			a
		ld			[grp_play_file], a

		; \XV
		dec			a
		ld			[grp_top_file], a
		xor			a, a
		call		grp_update_file_list
		ret
		endscope

; ==============================================================================
;	t@CǂݍŃ^Cg\XV
;	input)
;		hl .... t@CGg̃AhX
;	output)
;		Zf .... 1: , 0: s
; ==============================================================================
		scope		load_mgs_file_and_show_title
load_mgs_file_and_show_title::
		ld			[file_name_address], hl
		call		load_mgs_file
		ret			nz							; Zf = 0: s

		; clear song Title area
		xor			a, a
		ld			[file_name_copy + 8], a
		ld			[target_file_name_position], a
		ld			hl, (256 + 32) * 8
		ld			bc, 32 * 8
		call		FILVRM

		; draw song Title
		ld			hl, mgs_song_title
		ld			de, target_file_name
		ld			bc, target_file_name_end - target_file_name
		ldir									; page2 ɂȃf[^̃^Cg page0 ɃRs[

		call		update_title

		; copy file name
		ld			hl, [file_name_address]
		ld			de, file_name_copy
		ld			bc, 8
		ldir

		; clear file name area
		ld			hl, 251 * 8
		ld			bc, 4 * 8
		xor			a, a
		call		FILVRM

		; draw file name
		ld			hl, 251 * 8
		ld			de, file_name_copy
		call		draw_string

		xor			a, a					; Zf = 1: 
		ret
		endscope

; ==============================================================================
;	^Cg\XV
;	input)
;		--
;	output)
;		--
; ==============================================================================
		scope		update_title
update_title::
		ld			a, [target_file_name_position]
		ld			e, a
		ld			d, 0
		ld			hl, target_file_name
		add			hl, de
		ex			de, hl
		ld			hl, (256 + 32) * 8
		push		de
		call		draw_string					; page2 RAMƂėp
		pop			de

		or			a, a
		jp			z, skip1

		ld			a, [de]
		call		issjis1st
		ld			a, [target_file_name_position]
		jr			nc, skip2
		inc			a
skip2:
		inc			a
skip1:
		ld			[target_file_name_position], a
		ret
		endscope

; ==============================================================================
;	AɓĂl16iɕϊāA[HL]Ɋi[
; ==============================================================================
		scope		dec_to_hex
dec_to_hex::
		ld			b, a
		rrca
		rrca
		rrca
		rrca
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip1
		add			a, 'A' - '0' - 10
skip1:
		ld			[hl], a
		inc			hl
		ld			a, b
		and			a, 0x0F
		add			a, '0'
		cp			a, '9' + 1
		jr			c, skip2
		add			a, 'A' - '0' - 10
skip2:
		ld			[hl], a
		inc			hl
		ret
		endscope

; ==============================================================================
;	DATA AREA
; ==============================================================================
cliksw_backup::
		db			0
track_mute::
		db			0xFF, 0xFF, 0xFF			; L, H, B : BHLŉʂ 17bit LB1=ON, 0=MUTE
title_scroll_timer::
		db			title_scroll_wait

random_seed1::
		db			0xa3
random_seed2::
		db			0x5b
sort_mode::
		db			PRM_SORT_MODE		; \[g[h 0: Entry, 1: Title, 2: File name, 3: Shuffle
play_mode::
		db			PRM_PLAY_MODE		; 샂[h 0: Normal, 1: Random, 2: Repeat
playing_song_number::
		db			0					; Đ̋Ȃ̃t@Cԍ
play_state::
		db			0					; 0: ~, 1: ̋ȍĐ҂, 2: tF[hAEg, 3: Đ
fadeout_volume::
		db			0
fadeout_speed::
		db			1					; 1: slow speed ... 128: high speed
loop_counter::
		db			PRM_LOOP_COUNTER
master_volume::
		db			PRM_MASTER_VOLUME	; 0: Max, 15: Min
target_file_name_position::
		db			0					; ȖXN[\̈ʒu

		include	"MGSDRVCTL.ASM";
		include	"KEYINPUT.ASM";
		include	"FILE_ACCESS.ASM"
		include	"GRAPHIC.ASM"
		include	"GRAPHIC_DATA.ASM"
		include	"STRING.ASM"

		if $ >= 0x6000
			error "OUT OF MEMORY (" + $ + ")"
		else
			message "MGSP SIZE CHECK OK (" + $ + ")"
		endif
